=== debian/changelog ===
libjpeg-turbo (1:1.5.1-2mx15+1) mx; urgency=medium

  * Rebuild for MX-15.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 10 Nov 2016 13:46:25 -0800

libjpeg-turbo (1:1.5.1-2) unstable; urgency=medium

  * Declare env on MIPS on first use (Courtesy of Aurelien Jarno) (Closes: #841129)

 -- Ondřej Surý <ondrej@debian.org>  Thu, 20 Oct 2016 15:51:27 +0200

libjpeg-turbo (1:1.5.1-1) unstable; urgency=medium

  * Imported Upstream version 1.5.1

 -- Ondřej Surý <ondrej@debian.org>  Wed, 21 Sep 2016 14:01:53 +0200

libjpeg-turbo (1:1.5.0-1) unstable; urgency=medium

  * Imported Upstream version 1.5.0
  * Remove MIPS SIMD patch; merged upstream
  * Install libturbojpeg.pc to libturbojpeg0-dev
  * README is now README.md
  * Add the extra documentation to the package(s)
  * Migrate to automatic dbgsym packages and remove get-orig-source, uscan
    works just fine
  * Bump standards version to 3.9.8 (no change)
  * Bump debhelper compat to 10, but don't bump debhelper depends to allow
    backports
  * doc/html/search/all_74.js is not missing source

 -- Ondřej Surý <ondrej@debian.org>  Wed, 08 Jun 2016 11:05:07 +0200

libjpeg-turbo (1:1.4.2-2) unstable; urgency=medium

  * Only disable SIMD on x32 instead of enabling it everywhere else

 -- Ondřej Surý <ondrej@debian.org>  Mon, 01 Feb 2016 18:13:32 +0100

libjpeg-turbo (1:1.4.2-1) unstable; urgency=medium

  * Imported Upstream version 1.4.2
  * Reproducible builds are now achieved with --with-build-date
  * Rebase remaining patch on top of 1.4.2 release

 -- Ondřej Surý <ondrej@debian.org>  Mon, 01 Feb 2016 16:30:16 +0100

libjpeg-turbo (1:1.4.1-2) unstable; urgency=medium

  * Fix build error in MIPS SIMD when compiling with -mfpxx (Closes: #795845)
  * Add versioned provides for libjpeg62 (Closes: #787938)

 -- Ondřej Surý <ondrej@debian.org>  Wed, 26 Aug 2015 17:34:30 +0200

libjpeg-turbo (1:1.4.1-1) unstable; urgency=medium

  * Imported Upstream version 1.4.1
  * All patches except the reproducible build has been merged upstream

 -- Ondřej Surý <ondrej@debian.org>  Tue, 28 Jul 2015 08:23:22 +0200

libjpeg-turbo (1:1.4.0-7) unstable; urgency=medium

  * Add patch to make builds reproducible (Closes: #782893)
  * Adjust gbp.conf for releasing 1.4.0 to unstable
  * Upload to unstable

 -- Ondřej Surý <ondrej@debian.org>  Sun, 10 May 2015 22:14:45 +0200

libjpeg-turbo (1:1.4.0-6) experimental; urgency=medium

  * Remove architecture list in nasm B-D (Closes: #776877)

 -- Ondřej Surý <ondrej@debian.org>  Mon, 02 Feb 2015 21:12:29 +0100

libjpeg-turbo (1:1.4.0-5) experimental; urgency=medium

  * Add missing init_simd() call in jsimd_can_h2v[12]_merged_upsample
    functions in mips(el) SIMD and thus we can enable SIMD on mips(el)
    See https://sourceforge.net/p/libjpeg-turbo/bugs/83/ for a long
    version.
  
 -- Ondřej Surý <ondrej@debian.org>  Wed, 21 Jan 2015 17:13:23 +0100

libjpeg-turbo (1:1.4.0-4) experimental; urgency=medium

  * Enable hardening=+all in d/rules
  * Preserve user supplied CFLAGS by using foo_CPPFLAGS instead of
    foo_CFLAGS in Makefile.am

 -- Ondřej Surý <ondrej@debian.org>  Fri, 16 Jan 2015 09:15:29 +0100

libjpeg-turbo (1:1.4.0-3) experimental; urgency=medium

  * Disable SIMD on mips as well (and match x32 against DEB_HOST_ARCH)

 -- Ondřej Surý <ondrej@debian.org>  Thu, 15 Jan 2015 10:41:33 +0100

libjpeg-turbo (1:1.4.0-2) experimental; urgency=medium

  * Disable float tests (see https://sourceforge.net/p/libjpeg-turbo/bugs/83/
    for background)
  * Disable SIMD also on mipsel
  * Use architecture.mk for setting dpkg variables

 -- Ondřej Surý <ondrej@debian.org>  Wed, 14 Jan 2015 13:22:18 +0100

libjpeg-turbo (1:1.4.0-1) experimental; urgency=medium

  * Add gbp.conf for experimental (1.4) branch
  * New upstream version 1.4.0
  * Remove all Debian patches; merged upstream
  * Bump libturbojpeg SONAME to 0 to align with upstream and thus renamed
    libturbojpeg1* packages to libturbojpeg0*.

 -- Ondřej Surý <ondrej@debian.org>  Mon, 12 Jan 2015 12:11:11 +0100
