## libjpeg-turbo 1.5.2.6

=== debian/changelog ===
libjpeg-turbo (1:1.5.2.6-1+dde) unstable; urgency=medium

  * update

 -- Ondřej Surý <ondrej@debian.org>  Thu, 01 Apr 2021 21:31:42 +0800

libjpeg-turbo (1:1.5.2-2+deb10u1) buster; urgency=medium

  * CVE-2018-1152  (Closes: #902950)
  * CVE-2018-14498 (Closes: #924678)
  * CVE-2019-2201
  * CVE-2020-13790 (Closes: #962829)

 -- Moritz Mühlenhoff <jmm@debian.org>  Wed, 07 Oct 2020 22:25:43 +0200

libjpeg-turbo (1:1.5.2.5-1+dde) unstable; urgency=medium

  * fix  CVE-2018-14498 
  * fix  CVE-2019-2201

 -- liujianqiang <liujianqiang@uniontech .com>  Sun, 13 Dec 2020 12:03:21 +0800

libjpeg-turbo (1:1.5.2.4-1+dde) unstable; urgency=medium

  * Non-maintainer upload.
  * fix CVE-2018-11813

 -- zhouzilong <zhouzilong@uniontech.com>  Mon, 31 Aug 2020 12:15:35 +0800

libjpeg-turbo (1:1.5.2-3+dde2) unstable; urgency=medium

  * Non-maintainer upload.
  *    rebuild

 -- liuyong <liuyong@deepin.com>  Fri, 03 Jul 2020 10:58:51 +0800

libjpeg-turbo (1:1.5.2-3+dde) unstable; urgency=medium

  * add 0001-Merge-loongson-mmi-optimizations.patch

 -- jin bo <jinbo-hf@loongson.cn>  Thu, 30 Apr 2020 15:13:48 +0800
