## libjpeg-turbo 2.0.0

=== debian/changelog ===
libjpeg-turbo (2.0.0-0ubuntu2) cosmic; urgency=medium

  * Fix build dependencies.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 17 Sep 2018 12:04:40 +0200

libjpeg-turbo (2.0.0-0ubuntu1) cosmic; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 17 Sep 2018 11:03:11 +0200

libjpeg-turbo (1.5.2-0ubuntu5) artful; urgency=medium

  * Revert the last upload.
  * Move libturbojpeg.a to the libturbojpeg0-dev package.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 11 Oct 2017 07:07:23 +0200

libjpeg-turbo (1.5.2-0ubuntu4) artful; urgency=medium

  * Drop libturbojpeg.a static library in libturbojpeg0-dev package,
    already ship in jpeg-turbo8 package (this fixes the installability
    issue. The static library is still in libjpeg-turbo8-dev
    for retro-compatibility, the dynamic one is in
    libturbojpeg0-dev and libturbojpeg packages.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Oct 2017 16:48:35 +0200

libjpeg-turbo (1.5.2-0ubuntu3) artful; urgency=medium

  * libturbojpeg0-dev: Depend on libturbojpeg0-dev.
  * libturbojpeg0-dev: Include the turbojpeg.h header here.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 18 Sep 2017 18:10:01 +0200

libjpeg-turbo (1.5.2-0ubuntu2) artful; urgency=medium

  * libturbojpeg0-dev: Drop conflict with libjpeg-turbo8-dev, depend
    on it instead, and leave the header files libjpeg-turbo8-dev.
    This stops pulling the legacy turbojpeg API into main. See the README
    in the sources ("Using libjpeg-turbo").
    There is no reason to pull libturbojpeg0-dev and libturbojpeg0 into main.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 18 Sep 2017 12:40:49 +0200

libjpeg-turbo (1.5.2-0ubuntu1) artful; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 12 Sep 2017 14:17:22 +0200

libjpeg-turbo (1.5.1-0ubuntu2) artful; urgency=medium

  * Install turbojpeg development file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 Sep 2017 12:49:04 +0200

libjpeg-turbo (1.5.1-0ubuntu1) zesty; urgency=medium

  * New upstream version.
  * Keep the Ubuntu packaging.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 02 Nov 2016 16:58:27 +0100

libjpeg-turbo (1.5.0-0ubuntu1) yakkety; urgency=medium

  * New upstream version.
  * Keep the Ubuntu packaging.
  * Update symbols file.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 02 Aug 2016 13:36:10 +0200
